<template>

  <div class="main-contain">
    <div class="position">
      <bread-crumb v-if="type == 1" :crumbs='crumbs'></bread-crumb>
      <bread-crumb v-if="type == 2" :crumbs='crumbs2'></bread-crumb>

      <div style="float:right;">
        <el-button size="small" @click="back()" class="filter-item">取 消</el-button>
        <el-button size="small" type="primary" @click="submit()" class="filter-item">保 存</el-button>
      </div>
    </div>
    <div class="app-container">

      <!--<stock-in-dialog ref="dialog" :propForm="propForm"-->
                       <!--:visibility="isVisibility"-->
                       <!--v-on:dialog-comfirm="comfirm"-->
                       <!--v-on:dialog-cancle="cancle"></stock-in-dialog>-->
      <drugs-stock-dialog
        ref="dialog"
        :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      ></drugs-stock-dialog>


      <div class="cell clearfix">
        <label class="title"><span class="name">入库时间</span> : </label>
        <el-date-picker size="small" v-model="warehousing_time" prefix-icon="el-icon-date" :editable="false"
                        style="width: 196px;" type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                        value-format="yyyy-MM-dd"></el-date-picker>
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">经销商</span> : </label>
        <el-select size="small" v-model="form.dealer" clearable placeholder="请选择经销商" @change="changeDealer">
          <el-option
            v-for="(option, index) in dealer"
            :key="index"
            :label="option.dealer_name"
            :value="option.id">
          </el-option>
        </el-select>
      </div>

      <div class="cell clearfix">
        <label class="title"><span class="name">厂商</span> : </label>

        <el-select size="small" v-model="form.manufacturer" clearable placeholder="请选择厂商"
                   @change="changeManufacturer">
          <el-option
            v-for="(option, index) in manufacturer"
            :key="index"
            :label="option.manufacturer_name"
            :value="option.id">
          </el-option>
        </el-select>
      </div>

      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table
          id="oictable"
          :data="recordInfo.recordData"
          :class="signAndWeighBoxPatients"
          style="width: 100%"
          border
          max-height="450"
          :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)' }"
        >
          <el-table-column align="center" width="200">
            <template slot="header" slot-scope="scope">
              <span>药品名称<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入药品名称"
                  v-model="scope.row.drug_id"
                  :value="typeName(scope.row.drug_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column align="center" width="200">
            <template slot="header" slot-scope="scope">
              <span>规格名称<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 15px">
                <el-input
                  placeholder="请输入规格名称"
                  v-model="scope.row.drug_id"
                  :value="specificationName(scope.row.drug_id)"
                  @focus="showDialog(scope.$index, scope.row)"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>进价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <!--<el-input type="number" v-model="scope.row.price"  @blur="handleBlur(scope.$index, scope.row)"></el-input>-->
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column align="center" width="180">
            <template slot="header" slot-scope="scope">
              <span>入库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <!--{{scope.row.warehousing_count}}-->
              <!--<el-input type="number" v-model="scope.row.warehousing_count"   @blur="handleBlur(scope.$index, scope.row)"></el-input>-->

              <el-form-item
                :prop="'recordData.' + scope.$index + '.warehousing_count'"
                :rules="tableRules.warehousing_count"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入入库数量"
                  type="number"
                  v-model="scope.row.warehousing_count"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column label="进价总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.warehousing_count) }}
            </template>
          </el-table-column>

          <el-table-column label="零价" align="center" width="150">
            <template slot-scope="scope">
              {{ scope.row.retail_price }}
            </template>
          </el-table-column>

          <el-table-column label="零价总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.retail_price * scope.row.warehousing_count) }}
            </template>
          </el-table-column>
          <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>批号</span>
            </template>
            <template slot-scope="scope">
              <el-form-item>
                <el-input
                  placeholder="请输入批号"
                  v-model="scope.row.number"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="生产日期" width="250" align="center">
            <template slot-scope="scope">
              <!--{{scope.row.product_date | parseTime("{y}-{m}-{d}")}}-->
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.product_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="有效日期" width="250" align="center">
            <template slot-scope="scope">
              <!--{{ scope.row.expiry_date | parseTime("{y}-{m}-{d}")}}-->
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.expiry_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="备注" width="150" align="center">
            <template slot-scope="scope">
              <el-input v-model="scope.row.remark"></el-input>
            </template>
          </el-table-column>

          <el-table-column
            label="操作"
            fixed="right"
            align="center"
            width="150"
          >
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
      </el-form>


    </div>
  </div>

</template>

<script>
  import { uParseTime } from '@/utils/tools'

  import {
    GetAllConfig,
    GetAllDrugInfoByID,
    postDrugWarehouse
  } from "@/api/drug/drug_stock";
  import BreadCrumb from '../../components/bread-crumb'
  import DrugsStockDialog from './drugsStockDialog/index'

  export default {
    components: { DrugsStockDialog, BreadCrumb },
    name: 'stockIn',

    data() {
      var checkGoodId = (rule, value, callback) => {
        setTimeout(() => {
          if (value == '' || value == 0) {
            return callback(new Error('规格名称不能为空'))
          }
        }, 2000)
      }

      return {
        crumbs: [
          { path: false, name: '库存管理' },
          { path: false, name: "药品入库单" },
          { path: false, name: "新增入库单" }
        ],
        crumbs2: [
          { path: false, name: '库存管理' },
          { path: false, name: '其他入库单' },
          { path: false, name: '新增入库单' }
        ],
        signAndWeighBoxPatients: 'sign-and-weigh-box-patients',
        warehousing_time: '',
        adminUserOptions: null,
        currentIndex: 0,

        recordInfo: {
          recordData: [],
          stock_in_code: '',
          current_index: ''

        },
        tableRules: {
          price: [
            { required: true, message: '单价不能为空', trigger: 'blur' }
          ],
          warehousing_count: [
            { required: true, message: '数量不能为空', trigge: 'blur' }
          ],

          good_id: [
            { validator: checkGoodId, trigger: 'blur' }
          ]

        },
        type: this.$route.query.type,
        total: '',
        product_date: '',
        expiry_date: '',
        numbers: '',

        // prop
        isVisibility: false,
        propForm: {
          goods: [],
          goodType: [],
          goodInfo: [],
          goodUnit: [],
          title: '入库',
          formValue: {
            good_type_id: '',
            good_id: '',
            number: '',
            product_date: '',
            expiry_date: '',
            warehousing_count: '',
            price: '',
            remark: '',
            dealer: '',
            manufacturer: ''

          },
          isCreated: 1

        },
        form: {
          manufacturer: '',
          dealer: ''
        },

        formValue: {
          good_type_id: '',
          good_id: '',
          number: '',
          product_date: '',
          expiry_date: '',
          warehousing_count: '',
          price: '',
          remark: '',
          dealer: '',
          manufacturer: ''

        },

        manufacturer: [],
        dealer: [],
        goodType: [],
        goodInfo:[]
      }
    },
    methods: {
      handleSave: function() {
        if (this.recordInfo.recordData.length <= 0) {
          this.$message.error('请添加入库信息')
          return
        }
        sessionStorage.removeItem('warehousing_orders')
        this.$router.back(-1)
      }, handleCancle: function() {
        this.$confirm('是否放弃编辑返回上一页?', '放弃编辑', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          sessionStorage.removeItem('warehousing_orders')
          this.$router.back(-1)
        }).catch(() => {

        })
      }, handleCreate: function() {

        this.propForm.formValue = {}
        this.propForm.isCreated = 1
        this.isVisibility = true
      }, comfirm: function(val) {

        this.$refs.dialog.hide()
        if (val.selectedGoodInfo.length > 0) {
          for (let i = val.selectedGoodInfo.length - 1; i >= 0; i--) {
            if (i == 0) {
              this.recordInfo.recordData[this.currentIndex].drug_id = val.selectedGoodInfo[i].id
              this.recordInfo.recordData[this.currentIndex].price = val.selectedGoodInfo[i].last_price.toString()
              this.recordInfo.recordData[this.currentIndex].retail_price = val.selectedGoodInfo[i].retail_price.toString()

            } else {
              const tempForm = {}
              tempForm["id"] = 0;
              tempForm['drug_id'] = val.selectedGoodInfo[i].id
              tempForm['number'] = ''
              tempForm['product_date'] = ''
              tempForm['expiry_date'] = ''
              tempForm['warehousing_count'] = ''
              tempForm['retail_price'] = val.selectedGoodInfo[i].retail_price.toString()
              tempForm['price'] =  val.selectedGoodInfo[i].last_price.toString()
              tempForm['remark'] = ''
              tempForm['dealer'] = ''
              tempForm['manufacturer'] = ''
              this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
            }
          }
        }

        this.currentIndex = -1
      }, cancle: function() {
        this.$refs.dialog.hide()
      },  GetConfigInfo: function() {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })

        GetAllConfig().then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.manufacturer = response.data.data.manufacturer;
            this.dealer = response.data.data.dealer;
            for(let i = 0; i<  response.data.data.drugs.length;i++){
              this.goodType.push(response.data.data.drugs[i])
              if(response.data.data.drugs[i].drug_specs != null) {
                for (let b = 0; b < response.data.data.drugs[i].drug_specs.length; b++) {
                  this.goodInfo.push(response.data.data.drugs[i].drug_specs[b])
                }
              }
            }
            this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: "全部" });
            this.dealer.splice(0, 0, { id: 0, dealer_name: "全部" });

            this.form.manufacturer = 0
            this.form.dealer = 0
          }
          loading.close()

        })
      }, typeName: function(drug_id) {
        let name = "";
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == drug_id) {
            name = this.goodInfo[i].drug_name;

          }
        }
        return name;
      }, specificationName: function(drug_id) {
        let name = "";
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == drug_id) {
            name = this.goodInfo[i].drug_spec;
          }
        }
        return name;
      }, handleEdit: function(index, row) {
        const tempObj = {}
        tempObj['drug_id'] = 0
        tempObj['number'] = ''
        tempObj['product_date'] = ''
        tempObj['expiry_date'] = ''
        tempObj['warehousing_count'] = ''
        tempObj['retail_price'] = ''
        tempObj['price'] = ''
        tempObj['remark'] = ''
        tempObj['dealer'] = ''
        tempObj['manufacturer'] = ''
        this.recordInfo.recordData.push(tempObj)
      }, handleDelete: function(index, row) {
        if (this.recordInfo.recordData.length <= 1) {
          this.$message.error('只有一条记录的时候无法删除')
          return
        } else {
          this.recordInfo.recordData.splice(index, 1)
        }
      }, calculate: function(val) {
        if (val == 0) {
          return ''
        }
        return Math.round(parseFloat(val) * 100) / 100
      },
      // GetWarehouseInfoByOrdeNumber: function() {
      //   const params = {
      //     'warehousing_order': sessionStorage.getItem('warehousing_orders')
      //   }
      //   this.recordInfo.recordData = []
      //   getWarehouseInfoByOrdeNumber(params).then(response => {
      //     if (response.data.state != 0) {
      //       for (let i = 0; i < response.data.data.info.length; i++) {
      //         this.recordInfo.recordData.push(response.data.data.info[i])
      //       }
      //     }
      //   })
      // },
      getTime(val, temp) {
        if (val != 0) {
          return uParseTime(val, temp)
        } else {
          return ''
        }
      },
      showDialog(index, row) {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })
        this.currentIndex = index
        this.isVisibility = true
        const params = {
          manufacturer_id: this.form.manufacturer,
          dealer_id: this.form.dealer
        }
        GetAllDrugInfoByID(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg)
              return false
              loading.close()

            } else {
              loading.close()

              if (response.data.data.drugs.length <= 0) {
                this.$message.error('该厂商或经销商没有药品信息')
                return
              }
              this.$refs.dialog.show()
              for (let i = 0; i < response.data.data.drugs.length; i++) {
                this.propForm.goods.push(
                  response.data.data.drugs[i]
                );
              }
              const obj = {};
              this.propForm.goods = this.propForm.goods.reduce(
                (cur, next) => {
                  obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
                  return cur;
                },
                []
              ); // 设置cur默认类型为数组，并且初始值为空的数组
            }

            for (let i = 0; i < this.propForm.goods.length; i++) {
              for (let a = 0; a < this.propForm.goods[i].drug_specs.length; a++) {
                var respObj = this.propForm.goods[i].drug_specs[a];
                respObj["isSelected"] = false;
              }
            }
          }
        )
      },
      getSummaries(param) {
        const { columns, data } = param
        const sums = []
        columns.forEach((column, index) => {
          if (index === 0) {
            sums[index] = '总价'
            return
          }
          const values = data.map(item => Number(item[column.property]))
          if (!values.every(value => isNaN(value))) {
            sums[index] = values.reduce((prev, curr) => {
              const value = Number(curr)
              if (!isNaN(value)) {
                return prev + curr
              } else {
                return prev
              }
            }, 0)
            sums[index] += ' 元'
          } else {
            sums[index] = 'N/A'
          }
        })

        return sums
      }
      ,
      back() {
        this.$router.go(-1)
      }
      ,
      submit() {
        this.$refs['tableForm'].validate((valid) => {
          if (valid) {
            const array = this.recordInfo.recordData
            console.log(array)
            for (let i = 0; i < array.length; i++) {

              if (array[i].drug_id == 0) {
                this.$message.error('药品名称或者药品规格名称不能为空')
                return
              }
            }

            if(this.recordInfo.recordData.length <= 0){
              this.$message.success('请添加入库商品')
              return
            }

            const params = {
              'stockIn': this.recordInfo.recordData
            }
            postDrugWarehouse(params, this.warehousing_time, this.form.manufacturer, this.form.dealer, this.type).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg)
                return false
              } else {
                this.$message.success('入库成功')

                this.$router.back(-1)
              }
            })
          } else {
            return false
          }
        })
      }
      ,
      changeManufacturer(val) {

      }, changeDealer(val) {

      }
    }
    ,
    created() {
      var nowDate = new Date()
      var nowYear = nowDate.getFullYear()
      var nowMonth = nowDate.getMonth() + 1
      var nowDay = nowDate.getDate()
      this.warehousing_time =
        nowYear +
        '-' +
        (nowMonth < 10 ? '0' + nowMonth : nowMonth) +
        '-' +
        (nowDay < 10 ? '0' + nowDay : nowDay)
      const tempObj = {}
      tempObj['drug_id'] = 0
      tempObj['number'] = ''
      tempObj['product_date'] = ''
      tempObj['expiry_date'] = ''
      tempObj['warehousing_count'] = ''
      tempObj['retail_price'] = ''
      tempObj['price'] = ''
      tempObj['remark'] = ''
      tempObj['dealer'] = ''
      tempObj['manufacturer'] = ''

      this.recordInfo.recordData.push(tempObj)
      this.GetConfigInfo()
      this.propForm.goodUnit = this.$store.getters.good_unit
    }

  }
</script>

<style>
  #oictable ::-webkit-scrollbar {
    height: 15px;
  }
</style>

<style rel="stylesheet/css" lang="scss" scoped>
  .information {
    border: 1px #dcdfe6 solid;
    padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }

  }

  .edit_separater {
    border-top: 1px solid rgb(233, 233, 233);
    margin-top: 15px;
    margin-bottom: 15px;
  }

</style>

<style>
  .sign-and-weigh-box .sign-and-weigh-box-patients .cell {
    font-size: 12px;
  }

  .sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
    background: #6fb5fa;
  }

</style>
